//============================================================================//
//
// HPB_bot2.cpp - bot source code file (Copyright 2004, Jeffrey "botman" Broome)
//
//============================================================================//

#include <stdio.h>

#include "interface.h"
#include "filesystem.h"
#include "engine/iserverplugin.h"
#include "dlls/iplayerinfo.h"
#include "eiface.h"
#include "igameevents.h"

#include "usercmd.h"
#include "bitbuf.h"
#include "in_buttons.h"

#include "HPB_bot2.h"

// memdbgon must be the last include file in a .cpp file!!!
#include "tier0/memdbgon.h"

#define BUF_SIZE 64  // really only need 249 bits (32 bytes) + WEAPON_SUBTYPE_BITS (whatever that is)

bot_t gBots[32];  // bot private data stuff (see bot.h file for details)


void CreateBot(const char* name)
{
	edict_t *pEdict = engine->CreateFakeClient( name );

	if (!pEdict)
	{
		Msg("CreateBot: ERROR - Counldn't create a bot!!!\n");
		return;
	}

//	ClientPutInServer(pEdict, name);  // you don't need this for bots in Source

//	pPlayer->ClearFlags();
//	pPlayer->AddFlag( FL_CLIENT | FL_FAKECLIENT );

	bot_t *pBot = &gBots[ engine->IndexOfEdict(pEdict) - 1 ];

	// initialize any private bot data here...
	pBot->edict = pEdict;
	pBot->fCreateTime = engine->Time();
	pBot->fJoinTime = pBot->fCreateTime + 1.0;  // time when bot does stuff to join game (team select, etc)

	Msg("CreateBot: bot was added successfully to server\n");
}

// see CBasePlayer::RunNullCommand() for example of PlayerRunCommand()...
void BotRunPlayerMove(bot_t* pBot)
{
	CUserCmd cmd;
	bf_write write_buf;
	bf_read read_buf;
	unsigned char buffer[BUF_SIZE];  // shared buffer between write_buf and read_buf (EVIL!!!)

	memset(&cmd, 0, sizeof(cmd));

	cmd.forwardmove = 200.0f;
	cmd.sidemove = 0;
	cmd.upmove = 0;
	cmd.buttons = 0;
	if ((rand() % 2) == 0)
		cmd.buttons |= IN_JUMP;  // bunny hopping bastards!!!
	cmd.impulse = 0;

//	if ( pPlayer->IsDead() ) // respawn dead players
//	{
//		if (RandomInt(0,1))
//			cmd.buttons = 0;
//		else
//			cmd.buttons = IN_ATTACK;
//	}

	write_buf.StartWriting( buffer, BUF_SIZE );

	WriteUsercmd( &write_buf, &cmd );  // by magic the same data appears in the read_buf!!!

	read_buf.StartReading( buffer, BUF_SIZE );  // this is truly EVIL!!!

	gameclients->ProcessUsercmds(pBot->edict, &read_buf, 1, 1, 0, false, false);
}

void BotJoinGame(bot_t* pBot)
{
	// do whatever is necessary here to join the game...
	IPlayerInfo* pInfo = playerinfomanager->GetPlayerInfo(pBot->edict);

	pInfo->ChangeTeam(2);
}

void BotThink(edict_t* pEdict)
{
	bot_t *pBot = &gBots[ engine->IndexOfEdict(pEdict) - 1 ];

	float current_time = engine->Time();

	if ((pBot->fJoinTime > 0.0f) && (pBot->fJoinTime < current_time))
	{
		BotJoinGame(pBot);
		pBot->fJoinTime = -1.0f;  // don't need to join game now
	}

	BotRunPlayerMove(pBot);
}
