//=============================================================================//
//
// HPB_bot2.h - bot header file (Copyright 2004, Jeffrey "botman" Broome)
//
//=============================================================================//

#ifndef HPB_BOT2_H
#define HPB_BOT2_H

#include "usercmd.h"


typedef struct
{
	edict_t*	edict;
	float		fCreateTime;	// time bot was created
	float		fJoinTime;		// time when bot should do stuff to join the game (select team, etc)
} bot_t;


// Interfaces from the engine
extern IVEngineServer *engine;  // helper functions (messaging clients, loading content, making entities, running commands, etc)
extern IFileSystem *filesystem;  // file I/O 
extern IGameEventManager *gameeventmanager;  // game events interface
extern IPlayerInfoManager *playerinfomanager;  // game dll interface to interact with players
extern IServerPluginHelpers *helpers;  // special 3rd party plugin helpers from the engine
extern IServerGameClients* gameclients;


// function prototypes...
void CreateBot(const char* name);
void BotThink(edict_t* pEdict);
void WriteUsercmd( bf_write *buf, CUserCmd *cmd );


// useful helper funcs...
inline bool FStrEq(const char *sz1, const char *sz2)
{
	return(Q_stricmp(sz1, sz2) == 0);
}

inline edict_t* INDEXENT( int iEdictNum )		
{ 
	return engine->PEntityOfEntIndex(iEdictNum); 
}

#endif // HPB_BOT2_H
